/*
Silvia Marogel, 335CB - Pain electritc - source code
*/

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <string.h>


int notes[8] = {262, 294, 330, 349, 392, 440, 494, 523};

unsigned int songs[5][100];
int songs, song_size;

unsigned int n;

int mode;
int play_mode;
int record_mode;
int k;

void init_piano(){
	//init difuzor
	//PA0
	DDRA |= (1 << PA0);
	PORTA = &= ~((1 << PA0));
	
	//init butoane - claviatura
	//PB0,1,2,3,4,7 + PD0, PD1
	PORTB |= (1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB3) | (1 << PB4) | (1 << PB7); 
	PORTD |= (1 << PD0) | (1 << PD1);
	DDRB &= ~((1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB3) | (1 << PB4) | (1 << PB7));
	DDRD &= ~((1 << PD0) | (1 << PD1));
	
	//init butoane - control
	//PD2,3,4
	PORTD |= (1 << PD2) | (1 << PD3) \| (1 << PD4);
	DDRD &= ~((1 << PD2) | (1 << PD3) \| (1 << PD4));
	
	//init led-uri
	//PC0,1
	DDRC |= (1 << PC0) | (1 << PC1);
	PORTC &= ~((1 << PC0) | (1 << PC1));
	
}

int get_note(){
	int note = -1;
	
	//choose note
	if ((PINB & (1 << PB0)) == 0)
		note = 0;
	if ((PINB & (1 << PB1)) == 0)
		note = 1;
	if ((PINB & (1 << PB2)) == 0)
		note = 2;
	if ((PINB & (1 << PB3)) == 0)
		note = 3;
	if ((PINB & (1 << PB4)) == 0)
		note = 4;
	if ((PINB & (1 << PB7)) == 0)
		note = 5;
	if ((PIND & (1 << PD0)) == 0)
		note = 6;
	if ((PIND & (1 << PD1)) == 0)
		note = 7;
		
	return note;
}

void play_note(int note){
	
	float periods = 100000 / note;
	int i;
	
	for (i = 0; i < periods/2; i++)
		_delay_us(1);
	for (i = 0;i < periods/2;i++){
		PORTA ^= (1 << PA0);
		_delay_us(2);
	}
	for (i = 0;i < periods/2; i++)
		_delay_us(1);
}

void play(){
	//aprinde LED PC1
	PORTC = (1 << PC1);
	play_mode = 1;
	
	int i,j;
	
	
	for (i = 0;i < song_size; i++){
		play_note(songs[k][i]);
		_delay_us(1);
	}
	
	PORTA &= ~(1 << PA0);
	
	//fa lumina amuzanta la LED - todo

}

void reset_rec(int k){

	for (i = 0; i < 100; i++)
		songs[k][i] = 0;
}

void record(){
	//aprinde LED rosu - record mode
	PORTC = (1 << PC0);
	play_mode = -1;
	
	n = get_note();
	int i = songs, j = 0;
	
	//daca apasa buton record din nou - LED off
	//if LED off - canta fara record
	if (n != -1){
		if (record_mode == 1){ //record
			play_note(notes[n]);
			_delay_ms(5);
		
			songs[songs][j] = notes[n];
			song_size++;
			j++;
		}
		else if (record_mode == 0){ //canta liber
			PORTC &= ~(1 << PC0);
			play_note(notes[n]);
			_delay_us(5);
		}
	}
		
	_delay_ms(10);
	
	n = -1;
	
}

void next_song(){

	//butonul next song este apasat iar pianul era deja in play mode
	if (((PIND & (1 << PD4)) == 0) && play_mode == 1){
		_delay_ms(10);
		k++;
		if (k == 4){
			k = 0;
		}
		play();
	}

}

void update(){

	if ((PIND & (1 << PD2)) == 0)
		mode = 0; //play
		
	if ((PIND & (1 << PD3)) == 0){
		record_mode ^= 1;
		mode = 1; //record
	}
		
	if ((PIND & (1 << PD4)) == 0)
		mode = 2; //next_song
}


int main(){

	init_piano();
	n = -1;
	k = 0;
	
	mode = -1;
	
	while(1){
		if (mode == 0)
			play();
		if (mode == 1)
			record();
		if (mode == 2)
			next_song();
			
		update();
	}

	return 0;
}